local ANFrame = CreateFrame("Frame")
local ANEvents = {}
local defaultAutoNomiOptions = {}
defaultAutoNomiOptions['AutoNomiEnabled'] = true
defaultAutoNomiOptions['AutoNomiUsedMats'] = {}
defaultAutoNomiOptions['AutoNomiDoNotUse'] = {}

function ANMessage(message)
    DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ff[AutoNomi]|r: " .. message)
end

function ANEvents:GOSSIP_SHOW(arg1)
    if (AutoNomiOptions['AutoNomiEnabled'] == false) or (GossipFrameNpcNameText:GetText() ~= "Nomi") then
        return
    end

    local _, _, shipmentCapacity, shipmentsReady, shipmentsTotal, _, _, timeleftString = C_Garrison.GetLandingPageShipmentInfoByContainerID(122);

    if (timeleftString ~= nil) and (shipmentsTotal == shipmentCapacity) then
        ANMessage(' The queue is full come back in ' .. timeleftString)
        if (shipmentsReady > 0) then
            ANMessage(' You may need to open the Class Hall Report window to refresh the counter')
        end
        return
    end

    local title, gtype = {}, {}
    local mat = ''
    local numOptions = GetNumGossipOptions()

    title[1], gtype[1],
    title[2], gtype[2],
    title[3], gtype[3],
    title[4], gtype[4],
    title[5], gtype[5],
    title[6], gtype[6],
    title[7], gtype[7],
    title[8], gtype[8],
    title[9], gtype[9],
    title[10], gtype[10],
    title[11], gtype[11],
    title[12], gtype[12],
    title[13], gtype[13],
    title[14], gtype[14],
    title[15], gtype[15],
    title[16], gtype[16],
    title[17], gtype[17],
    title[18], gtype[18],
    title[19], gtype[19],
    title[20], gtype[20]
    = GetGossipOptions()

    for k, v in pairs(title) do
        if (gtype[k] == 'workorder') then
            --mat = v:sub(24)
            mat = v

            if (AutoNomiOptions['AutoNomiUsedMats'][mat]) then
                numOptions = numOptions - 1
            else
                ANFrame:RegisterEvent('SHIPMENT_CRAFTER_INFO')
                AutoNomiOptions['AutoNomiUsedMats'][mat] = true
                SelectGossipOption(k)
                break
            end
        else
            numOptions = numOptions - 1
        end
    end

    if (numOptions == 0) then
        ANMessage("Resetting used recipes")
        AutoNomiOptions['AutoNomiUsedMats'] = {}
    end
end

function ANEvents:ADDON_LOADED(self, name)
    if (name == "AutoNomi") then
        ANFrame:UnregisterEvent('ADDON_LOADED')
        ANMessage("v 1.1 Loaded")

        SlashCmdList["ANOMICMD"] = ANParseCommand
        SLASH_ANOMICMD1 = "/autonomi"
        SLASH_ANOMICMD2 = "/anomi"
    end
end

function ANEvents:SHIPMENT_CRAFTER_INFO(self, ...)
    ANFrame:UnregisterEvent('SHIPMENT_CRAFTER_INFO')

    if (AutoNomiOptions['AutoNomiEnabled'] == false) or (GossipFrameNpcNameText:GetText() ~= "Nomi") then
        return
    end

    local _, currentShipments, maxShipments = ...;
    if (currentShipments < maxShipments) then
        local itemName, textureID, quality, needed, quantity, itemID = C_Garrison.GetShipmentReagentInfo(1);

        if (AutoNomiOptions['AutoNomiDoNotUse'][itemID]) then
            ANMessage("BLAKLISTED " .. " |T" .. textureID .. ":24|t " .. itemName)
        else
            ANMessage("Selected research for " .. " |T" .. textureID .. ":24|t " .. itemName)
            GarrisonCapacitiveStartWorkOrder_OnClick()
        end
        GarrisonCapacitiveDisplayFrame_OnHide()
    else
        ANMessage("Reached max recipes")
    end
end

function ANEvents:VARIABLES_LOADED()
    ANFrame:UnregisterEvent('VARIABLES_LOADED')

    if (AutoNomiOptions == nil) then
        AutoNomiOptions = defaultAutoNomiOptions
    end

    if (AutoNomiOptions['AutoNomiDoNotUse'] == nil) then
        AutoNomiOptions['AutoNomiDoNotUse'] = defaultAutoNomiOptions['AutoNomiDoNotUse']
    end
    if (AutoNomiOptions['AutoNomiUsedMats'] == nil) then
        AutoNomiOptions['AutoNomiUsedMats'] = defaultAutoNomiOptions['AutoNomiUsedMats']
    end
    if (AutoNomiOptions['AutoNomiEnabled'] == nil) then
        AutoNomiOptions['AutoNomiEnabled'] = defaultAutoNomiOptions['AutoNomiEnabled']
    end

    if (AutoNomiOptions['AutoNomiEnabled']) then
        ANMessage(' - Enabled')
    else
        ANMessage(' - Disabled')
    end
end

ANFrame:SetScript("OnEvent", function(self, event, ...)
    ANEvents[event](self, self, ...)
end)

for k, v in pairs(ANEvents) do
    ANFrame:RegisterEvent(k)
end
ANFrame:UnregisterEvent('SHIPMENT_CRAFTER_INFO')

function ANParseCommand(cmd, extra)
    local goodcmd = false;
    if (cmd:upper() == "OFF") then
        goodcmd = true
        AutoNomiOptions['AutoNomiEnabled'] = false
        ANMessage(' - Disabled')
    end
    if (cmd:upper() == "ON") then
        goodcmd = true
        AutoNomiOptions['AutoNomiEnabled'] = true
        ANMessage(' - Enabled')
    end
    if (cmd:upper() == "RESTART") then
        goodcmd = true
        AutoNomiOptions['AutoNomiUsedMats'] = {}
        ANMessage(' - Starting from the top')
    end
    if (cmd:upper() == "ILIKEBACON") then
        goodcmd = true
        if (AutoNomiOptions['AutoNomiDoNotUse'][133923]) then
            AutoNomiOptions['AutoNomiDoNotUse'][133923] = nil
            ANMessage(' - Using bacon for research')
        else
            AutoNomiOptions['AutoNomiDoNotUse'][133923] = true
            ANMessage(' - NOT Using bacon for research')
        end
    end
    if (cmd:upper() == "TOGGLE") then
        goodcmd = true
        ANMessage("/autonomi toggle itemlink => toggle the use of that material")
    end
    if (goodcmd == false) then
        local isMatch, _, subcmd, itemLink = cmd:find("([^ ]+) (.*)")

        if (isMatch == 1) and (subcmd:upper() == "TOGGLE") then
            local itemID = select(3, strfind(itemLink, "item:(%d+)"));
            itemID = tonumber(itemID) and (itemID ~= nil) or 0

            if (itemID > 0) then
                if (AutoNomiOptions['AutoNomiDoNotUse'][itemID]) then
                    AutoNomiOptions['AutoNomiDoNotUse'][itemID] = nil
                    ANMessage(' - Using ' .. itemLink .. ' for research')
                else
                    AutoNomiOptions['AutoNomiDoNotUse'][itemID] = true
                    ANMessage(' - NOT Using ' .. itemLink .. ' for research')
                end
                goodcmd = true
            else
                ANMessage(' - Invalid ItemLink - use shift+click')
                ANMessage("/autonomi toggle itemlink => toggle the use of that material")
            end
        end
    end

    if (goodcmd == false) then
        ANMessage("CLI commands:")
        ANMessage("/anomi or /autonomi")
        ANMessage("/autonomi off => disable AutoNomi")
        ANMessage("/autonomi on => enable AutoNomi")
        ANMessage("/autonomi restart => start from the top of the list")
        ANMessage("/autonomi ilikebacon => toggle the use of bacon")
        ANMessage("/autonomi toggle itemlink => toggle the use of itemlink")
    end
end
